<script>
import config from '../../config';
import { required, requiredIf,numeric } from 'vuelidate/lib/validators';
import { outletService } from '../../services';
import { error_message, success_message } from '../../Helper/helper';
export default {
    data(){
        return {
            config:config,
            FormData:{
                taxtType:null,
                taxSlab:[]
            },
            taxtTyps:[
                { value: null, text: this.trans.get('__JSON__.Please select an option') },
                { value: 'included', text: this.trans.get('__JSON__.Items Are Included With Tax') },
                { value: 'excluded', text: this.trans.get('__JSON__.Items Are Excluded With Tax')},
            ],
            taxSlab:[{ id: '', tax_per: '',tax_name: '',tax_uniquecode: 'TS1' }]
        }
    },
    mounted(){
        this.getTax()
    },
    validations:{
        FormData:{
            taxtType:{
                required
            }
        },

        taxSlab:{
            $each:{
                id:{},
                tax_per:{                    
                    required: requiredIf(function() {
                        return (this.FormData.taxtType =='excluded')? true:false;
                    }),
                    numeric
                },
                tax_name:{
                    required: requiredIf(function() {
                        return (this.FormData.taxtType =='excluded')? true:false;
                    })
                },
                tax_uniquecode:{}
            }
        }
    },
    methods: {
        getTax(){
            outletService.getTaxSetting().then((response) => {
                if(response.data.code == 200){
                    if(Object.keys(response.data.result.taxSetting).length > 0){
                        this.FormData.taxtType = response.data.result.taxSetting.taxtType
                        if(Object.keys(response.data.result.taxSetting.taxSlab).length){
                            this.taxSlab = response.data.result.taxSetting.taxSlab
                        }
                    }

                }
            })
        },
        addTaxSlabField(){
            let code = 'TS'+(this.taxSlab.length + 1);
            this.taxSlab.push({ id: '', tax_per: '',tax_name: '',tax_uniquecode: code })
        },
        removeTaxSlabbField(index){
            this.taxSlab.splice(index,'1')
        },
        decNumberOnly(evt) {
            let val1 = evt.target.value;
            if (!(evt.keyCode == 46 || (evt.keyCode >= 48 && evt.keyCode <= 57))) {
                evt.preventDefault();
            }
            let partlen = val1.split(".").length - 1;
            if (evt.keyCode == 46 && partlen > 0) {
                evt.preventDefault();
            }
        },
        textFormSubmit(){
            this.$v.FormData.$touch()
            this.$v.taxSlab.$touch()
            if(this.$v.FormData.$invalid || this.$v.taxSlab.$invalid){
                return false
            }else{
                this.FormData.taxSlab = this.taxSlab
                let fd = new FormData();
                fd.append('taxSetting',JSON.stringify(this.FormData))
                outletService.taxSettingStoreUpdated(fd).then((response) => {
                    if(response.data.code == 200){
                        this.FormData.taxtType = response.data.result.taxSetting.taxtType
                        this.taxSlab = response.data.result.taxSetting.taxSlab
                        success_message(response.data.message)
                        this.$emit('actionChanged',4)
                    }else{
                        error_message(response.data.message)
                    }
                })
            }
        }
    }
}
</script>

<template>
    <div>
        <div class="row">
            <div class="col-12">
                <div class="card">
                    <div class="card-body">
                        <form @submit.prevent="textFormSubmit">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="row">
                                        <div class="col-md-4">
                                            <h5>Select Tax</h5>
                                        </div>
                                        <div class="col-md-8">
                                            <b-form-select 
                                            v-model="$v.FormData.taxtType.$model" 
                                            :options="taxtTyps"
                                            :class="{'is-invalid' : $v.FormData.taxtType.$error}"
                                            ></b-form-select>
                                            <div v-if="$v.FormData.taxtType.$error" class="invalid-feedback">
                                                <span v-if="!$v.FormData.taxtType.required">
                                                    {{ trans.get('__JSON__.Please select an option') }}
                                                </span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>                            
                            <div class="row mt-5" v-if="this.FormData.taxtType =='excluded'">
                                <div class="col-md-12"  v-for="(v,index) in $v.taxSlab.$each.$iter" :key="index">
                                    <div class="row mt-2" >
                                        <div class="col-md-2">
                                            <h6>{{ trans.get('__JSON__.VAT Code') }}</h6>
                                            <span style="font-weight: 500;font-size: 14px;">{{v.tax_uniquecode.$model}}</span>
                                        </div>
                                        <div class="col-md-4">
                                            <h6> {{ trans.get('__JSON__.Slab Name') }}</h6>
                                            <input 
                                            v-model="v.tax_name.$model" 
                                            name = "tax_name[]" 
                                            type="text" 
                                            class="form-control"
                                            :placeholder="trans.get('__JSON__.Slab Name')"
                                            :class="{'is-invalid' : v.tax_name.$error}"
                                            />
                                            <div v-if="v.tax_name.$error" class="invalid-feedback">
                                                <span v-if="!v.tax_name.required">
                                                    {{ trans.get('__JSON__.Please Enter A Slab Name') }}
                                                </span>
                                            </div>

                                        </div>
                                        <div class="col-md-4">
                                            <h6> {{ trans.get('__JSON__.VAT (In Percentage)') }}</h6>
                                            <input 
                                            v-model="v.tax_per.$model" 
                                            name = "tax_per[]" type="text" 
                                            @keypress="decNumberOnly($event)" 
                                            @paste.prevent 
                                            :placeholder="trans.get('__JSON__.VAT (In Percentage)')"
                                            class="form-control"
                                            :class="{'is-invalid' : v.tax_per.$error}"
                                            />

                                            <div v-if="v.tax_per.$error" class="invalid-feedback">
                                                <span v-if="!v.tax_per.required">
                                                    {{ trans.get('__JSON__.Please Enter A VAT (In Percentage)') }}
                                                </span>
                                            </div>
                                        </div>
                                        <div class="col-md-2">
                                            <h6>&nbsp;</h6>
                                            <button type="button" class="btn btn-primary btn-sm btn-rounded" @click.prevent="addTaxSlabField" v-if="$auth.hasPermission(config.permissions.outlet_write)">+</button>&nbsp;&nbsp;
                                            <button class="btn btn-danger btn-sm btn-rounded" v-if="index != 0 && index!='' && $auth.hasPermission(config.permissions.outlet_write)" @click.prevent="removeTaxSlabbField(index)">-</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-12 text-center mt-4">
                                    <button
                                        class="btn btn-primary"
                                        @click="$emit('actionChanged',2)"
                                        >{{ trans.get('__JSON__.Previous') }}
                                    </button>
                                    <button
                                        v-if="$auth.hasPermission(config.permissions.outlet_write)"
                                        class="btn btn-primary"
                                        type="submit"
                                        >{{ trans.get('__JSON__.Save') }}
                                    </button>
                                </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<style scoped>
.custom-select{
    width: 60% !important;
}
</style>